﻿using System;

namespace ROS.Base
{
    /// <summary>
    /// 状態変化メッセージイベントの引数として利用されます。
    /// </summary>
    /// <remarks>
    /// <para>
    /// 内部的に、コンソールに書いたりなんだりは決してしないので、イベントで処理してもらうためのもの。
    /// こうしておけば、サービスとしてパッケージしてもいいし、コンソールとしてパッケージしてもいいしね。
    /// </para>
    /// </remarks>
    public class ChangeStateMessageEventArgs : EventArgs
    {
        /// <summary>
        /// ChangeStateMessageEventArgs の新しいインスタンスを生成します。
        /// </summary>
        /// <param name="message">状態のメッセージ</param>
        public ChangeStateMessageEventArgs(string message)
        {
            this.Message = message;
        }

        /// <summary>
        /// 状態のメッセージを取得します。
        /// </summary>
        public string Message { get; private set; }
    }
}
