using System;
using System.Net.Sockets;
using System.Threading;
using System.Text;

namespace ROS.Base
{

    /// <summary>
    /// T[oNX̊Ƃ̂łB
    /// </summary>
    /// <remarks>
    /// <para>
    /// Ƃ肠APOPɊgo悤ɂĂ
    /// </para>
    /// </remarks>
    public abstract class ServerBase
    {
        //abstract
        #region ServerType / T[o̎ނ̕łB
        /// <summary>
        /// T[o̎ނ̕łB
        /// </summary>
        public abstract string ServerType { get; }
        #endregion

        #region IServerSettings / T[ȍԃNX擾܂B
        /// <summary>
        /// T[ȍԃNX擾܂B
        /// </summary>
        protected abstract IServerSettings State { get; }
        #endregion

        //event  On
        #region ChangeStateMessage / ԂύXꂽɔCxgłB
        /// <summary>
        /// ԂύXꂽɔCxgłB
        /// </summary>
        public event ChangeStateMessageHandler ChangeStateMessage;
        #endregion

        #region OnChangeStateMessage / ԂύXꂽbZ[W`Cxgł ChangeStateMessage 𔭐܂B
        /// <summary>
        /// ԂύXꂽbZ[W`Cxgł <see cref="ChangeStateMessage"/> 𔭐܂B
        /// </summary>
        /// <param name="message"></param>
        protected virtual void OnChangeStateMessage(string message)
        {
            if (this.ChangeStateMessage != null)
            {
                this.ChangeStateMessage(this, new ChangeStateMessageEventArgs(message));
            }
        } 
        #endregion




        //ҋ@Xbh
        //private member
        #region _waitThread / M҂Xbh
        /// <summary>
        /// M҂Xbh
        /// </summary>
        private Thread _waitThread = null;
        
        #endregion

        //public methoed
        #region Start / Jn̂߂̃\bh
        /// <summary>
        /// Jn̂߂̃\bh
        /// </summary>
        /// <remarks>
        /// <para>
        /// ̃\bh͊JnƁAVXbhĂāA҂
        /// </para>
        /// </remarks>
        /// <exception cref=" System.Net.Sockets.SocketException">MڑvȂ throw ܂B</exception>
        /// <exception cref="System.ArgumentNullException">TcpListener  throw ܂B</exception>
        /// <exception cref="System.ArgumentOutOfRangeException">TcpListener  throw ܂B</exception>
        public void Start()
        {
            this.OnChangeStateMessage(String.Format(Properties.Resources.TryingStartServer, this.ServerType));

            this._waitThread = new Thread(new ThreadStart(this.WaitThread));

            this._waitThread.Start();
        }
        #endregion

        #region Abort / Xbh𒆎~܂B
        /// <summary>
        /// Xbh𒆎~܂B
        /// </summary>
        public void Abort()
        {
            //~܂ꖽ
            _isListen = false;

            this.OnChangeStateMessage(String.Format(Properties.Resources.WaitingForThreadStop, this.ServerType));

            //܂܂ő҂
            _signalToWaitThredEnd.WaitOne();

            this.OnChangeStateMessage(String.Format(Properties.Resources.StopServer, this.ServerType));
        } 
        #endregion


        //ҋ@XbhNCAgXbhĂяoȂ񂾂肷邽߂̂́B{Iprivate
        //delegate
        #region ThreadMethodDelegate / XbhN邽߂ɗpfQ[gB
        /// <summary>
        /// XbhN邽߂ɗpfQ[gB
        /// </summary>
        /// <param name="serverSokectForClient">pT[oNCAgԂ̃\Pbg</param>
        delegate void ThreadMethodDelegate(Socket serverSokectForClient); 
        #endregion

        //volatiled member
        #region _isListen / ҋ@XbhListenԂ
        /// <summary>
        /// ҋ@XbhListenԂ
        /// </summary>
        private volatile bool _isListen = false;
        #endregion

        #region _signalToWaitThredEnd / ҋ@XbhI鎞ɗp
        /// <summary>
        /// ҋ@XbhI鎞ɗp
        /// </summary>
        private volatile AutoResetEvent _signalToWaitThredEnd = new AutoResetEvent(false);
        #endregion

        #region _clientCount / ݂̃NCAg̐ڑi܂AKlȂ̂ŁA܂҂Ȃj
        /// <summary>
        /// ݂̃NCAg̐ڑi܂AKlȂ̂ŁA܂҂Ȃj
        /// </summary>
        private volatile int _clientCount;
        #endregion

        #region countLockObject / _clientCount ̑ɎglockObject
        /// <summary>
        /// _clientCount ̑ɎglockObject
        /// </summary>
        private static object countLockObject = new object();
        #endregion

        //private methoed
        #region WaitThread / ҋ@Xbh
        /// <summary>
        /// ҋ@Xbh
        /// </summary>
        /// <remarks>
        /// <para>
        /// ŁANCAg̐ڑ҂B
        /// [ƁB
        /// </para>
        /// </remarks>
        private void WaitThread()
        {
            try
            {
                this.State.Listener.Start();

                _isListen = true;

                this.OnChangeStateMessage(String.Format(Properties.Resources.WaitingForClientConnection, this.ServerType));

                while (_isListen)
                {
                    if (this.State.Listener.Pending())
                    {
                        Socket serverSokectForClient = this.State.Listener.AcceptSocket();
                        serverSokectForClient.ReceiveTimeout = this.SocketReceiveTimeout;

                        if (IsAcceptClientThreadStart(serverSokectForClient))
                        {
                            //delegateƁAXbhv[ĝŒӂĂ
                            ThreadMethodDelegate clientThread = new ThreadMethodDelegate(ClientThread);

                            clientThread.BeginInvoke(serverSokectForClient, new AsyncCallback(EndClientThread), null);
                        }
                        else
                        {
                            this.OnChangeStateMessage(String.Format(Properties.Resources.ConnectionAlreadyUse, this.ServerType));
                        }
                    }
                    else
                    {
                        //ҋ@̂
                        Thread.Sleep(100);
                    }
                }
            }
            finally
            {
                this.State.Listener.Stop();
            }

            _signalToWaitThredEnd.Set();
        } 
        #endregion

        #region ClientThread / NCAgƂbƂ
        /// <summary>
        /// NCAgƂbƂ
        /// </summary>
        /// <param name="serverSokectForClient">\Pbg</param>
        /// <remarks>
        /// <para>
        /// MɁANCAgɃXbhNāAĂ΂ƂB
        /// ApŐi<see cref="CreateConversationUnit"/> ŐjNXgāAΘbĂ炤B
        /// </para>
        /// </remarks>
        private void ClientThread(Socket serverSokectForClient)
        {
            ConversationUnitBase convUnit = this.CreateConversationUnit();

            convUnit.SetSocket(serverSokectForClient);

            this.OnChangeStateMessage(String.Format(Properties.Resources.ClientConnectionFrom, this.ServerType, serverSokectForClient.RemoteEndPoint));

            try
            {
                convUnit.Converse();

                this.OnChangeStateMessage(String.Format(Properties.Resources.ExitedClientConnection, this.ServerType, serverSokectForClient.RemoteEndPoint));
            }
            catch (Exception ex)
            {
                this.OnChangeStateMessage(String.Format(Properties.Resources.ClientConnectionException, this.ServerType, serverSokectForClient.RemoteEndPoint, ex.ToString()));
            }
            finally
            {
                serverSokectForClient.Shutdown(SocketShutdown.Both);
                serverSokectForClient.Close();
            }
        } 
        #endregion

        //protected Overrideable
        #region MaxClientThread / ő̃NCAgXbh
        /// <summary>
        /// ő̃NCAgXbh
        /// </summary>
        /// <remarks>
        /// <para>
        /// delegategĂ̂ŁAXbhv[ɌEB
        /// [ƂŁANCAg̐ڑ𐧌邽߂̂́B
        /// </para>
        /// <para>
        /// ݒς邩Aς炱͕ύX
        /// </para>
        /// </remarks>
        protected virtual int MaxClientThread
        {
            get { return 25; }
        }
        #endregion

        #region IsAcceptClientThreadStart / ڑ邩w肵܂B
        /// <summary>
        /// ڑ邩w肵܂B
        /// </summary>
        /// <param name="serverSokectForClient">NCAgƂ̐ڑ</param>
        /// <returns>鎞true</returns>
        /// <remarks>
        /// <para>
        /// Invoke鏈̏ꍇ́A25XbhȂ悤ɂ悢
        /// </para>
        /// </remarks>
        protected virtual bool IsAcceptClientThreadStart(Socket serverSokectForClient)
        {
            if (this.MaxClientThread > this._clientCount)
            {
                lock (countLockObject)
                {
                    this._clientCount++;
                }
                return true;
            }
            else
            {
                return false;
            }
        }
        #endregion

        #region EndClientThread / NCAgXbh̏IɃR[obN郁\bh
        /// <summary>
        /// NCAgXbh̏IɃR[obN郁\bh
        /// </summary>
        /// <param name="ar">R[obNꂽ</param>
        protected virtual void EndClientThread(IAsyncResult ar)
        {
            lock (countLockObject)
            {
                this._clientCount--;
            }
        } 
        #endregion

        #region CreateConversationUnit / Θbp̃jbg𐶐ĕԂ܂B
        /// <summary>
        /// Θbp̃jbg𐶐ĕԂ܂B
        /// </summary>
        /// <returns>ꂽΘbjbg</returns>
        protected abstract ConversationUnitBase CreateConversationUnit(); 
        #endregion

        /// <summary>
        /// \Pbg̃^CAEg
        /// </summary>
        protected int SocketReceiveTimeout
        {
            get
            {
                return 30000;
            }
        }
    }
}
