﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ROS.Smtp
{
    /// <summary>
    /// 受信完了時に発生するイベントで利用される、イベントデータです。
    /// </summary>
    public class ReceiveCompletedEventArgs : EventArgs
    {
        /// <summary>
        /// ReceiveCompletedEventArgs の新しいインスタンスを生成します。
        /// </summary>
        /// <param name="mailMessage">受信したメールメッセージクラス。</param>
        public ReceiveCompletedEventArgs(MailMesage mailMessage)
        {
            this.Data = mailMessage;
        }

        /// <summary>
        /// 受信したメールメッセージクラスを取得します。
        /// </summary>
        public MailMesage Data { get; private set; }
    }
}
