﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ROS.Smtp
{
    /// <summary>
    /// SMTPサーバが返すメッセージのconstクラス
    /// </summary>
    public static class SmtpMessages
    {
        /// <summary>
        /// 220 OK を返す
        /// </summary>
        public const string OK220 = "220 OK SMTP Server is Ready" + SmtpCommands.CrLf;

        /// <summary>
        /// 250 OK を返す
        /// </summary>
        public const string OK250 = "250 OK" + SmtpCommands.CrLf;

        /// <summary>
        /// 354を返して、メールの受信を開始する文字列
        /// </summary>
        public const string StartMailInput354 = "354 Start mail input; end with <CRLF>.<CRLF>" + SmtpCommands.CrLf;

        /// <summary>
        /// VRFYの時に使うもの。めんどくせーから。
        /// </summary>
        public const string AddressUnknown550 = "550 Address Unknown" + SmtpCommands.CrLf;

        /// <summary>
        /// 221 OK を返して、コネクションをクローズしてもらう
        /// </summary>
        public const string ClosingConnection221 = "221 Closing Connection" + SmtpCommands.CrLf;
    }
}
